//
//  StreamMonitorSocketTableDataSource.m
//  GlowWorm
//
//  Created by Curtis Jones on 2007.02.22.
//  Copyright 2007 __MyCompanyName__. All rights reserved.
//

#import "StreamMonitorSocketTableDataSource.h"
#import "StreamMonitorDataView.h"
#import <Common.h>
#import <Logger.h>
#import <GlowWorm.h>


@implementation StreamMonitorSocketTableDataSource






///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark initalization functions





- (id)init
{
	self = [super init];
	
	if (self) {
		mList = nil;
	}
	
	return self;
}

- (void)dealloc
{
	[mList release];
	
	[super dealloc];
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark accessor functions (add/del)





- (void)setList:(NSMutableArray *)aList
{
	if (mList != nil)
		[mList release];
	
	mList = [aList retain];
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark accessor functions (misc)





- (int)count
{
	return [mList count];
}

- (NSArray *)getArray
{
	return mList;
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark miscellaneous functions




/*
- (void)showServiceNames:(BOOL)aBool
{
	mShowServiceNames = aBool;
}
*/




///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark data source functions (get)





- (int)numberOfRowsInTableView:(NSTableView *)aTableView
{
	return [self count];
}

- (id)tableView:(NSTableView *)aTableView objectValueForTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	NSString * column = [aTableColumn identifier];
	StreamMonitorDataView * view = [mList objectAtIndex:rowIndex];
	
	
	
	if ([column isEqualToString:@"name"])
		return [view name];
	
	else if ([column isEqualToString:@"xfer"])
		return [NSNumber numberWithUnsignedLong:[view xfer]];
	
	else
		return column;
}





///////////////////////////////////////////////////////////////////////////////

#pragma mark -
#pragma mark data source functions (set)





- (void)tableViewSelectionDidChange:(NSNotification *)aNotification
{
//GWLog(@"%s.. selectedRow = %d\n", __PRETTY_FUNCTION__, [mRuleTbl selectedRow]);
}

- (BOOL)tableView:(NSTableView *)aTableView shouldEditTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	GWLog(@"%s", __PRETTY_FUNCTION__);
	
	return FALSE;
}

- (void)tableView:(NSTableView *)aTableView setObjectValue:(id)anObject forTableColumn:(NSTableColumn *)aTableColumn row:(int)rowIndex
{
	GWLog(@"%s.. aTableColumn = %@, row = %d", __PRETTY_FUNCTION__, [aTableColumn identifier], rowIndex);
	
}





@end
